#pragma semicolon 1

#include <sourcemod>
#include <sdktools_functions>

public Plugin:myinfo = 
{
	name	= "C4 Progress Bar",
	author	= "wS (World-Source.Ru)",
	version = "1.0"
};

new Handle:g_Timer = INVALID_HANDLE;
new bool:g_ProgressBarEnabled;

public OnPluginStart()
{
	HookEvent("round_end",		RoundStartEnd,	EventHookMode_PostNoCopy);
	HookEvent("round_start",	RoundStartEnd,	EventHookMode_PostNoCopy);
	HookEvent("bomb_planted",	bomb_planted);
}

public RoundStartEnd(Handle:event, const String:name[], bool:silent)
{
	if (g_Timer != INVALID_HANDLE)
	{
		KillTimer(g_Timer);
		g_Timer = INVALID_HANDLE;
	}

	if (g_ProgressBarEnabled)
	{
		g_ProgressBarEnabled = false;
		for (new i = 1; i <= MaxClients; i++)
		{
			if (IsClientInGame(i) && IsPlayerAlive(i))
				SetEntProp(i, Prop_Send, "m_iProgressBarDuration", 0);
		}
	}
}

public bomb_planted(Handle:event, const String:name[], bool:silent)
{
	CreateTimer(0.1, wS, _, TIMER_FLAG_NO_MAPCHANGE);
}

public Action:wS(Handle:timer)
{
	decl c4;
	if ((c4 = FindEntityByClassname(-1, "planted_c4")) < 1)
		return Plugin_Stop;

	new Float:exp_time = GetEntPropFloat(c4, Prop_Send, "m_flC4Blow");
	new Float:cur_time = GetGameTime();
	new duration = RoundToCeil(exp_time - cur_time);
	if (duration < 1.0)
	{
		// wtf
		return Plugin_Stop;
	}

	if (duration <= 15)
	{
		wS_StartProgressBar(duration, cur_time);
	}
	else
	{
		if (g_Timer != INVALID_HANDLE) KillTimer(g_Timer);
		g_Timer = CreateTimer(float(duration - 15), wS_StartProgressBar_Timer);
	}

	return Plugin_Stop;
}

public Action:wS_StartProgressBar_Timer(Handle:timer)
{
	g_Timer = INVALID_HANDLE;
	wS_StartProgressBar(15, GetGameTime());
	return Plugin_Stop;
}

wS_StartProgressBar(Duration, Float:StartTime)
{
	g_ProgressBarEnabled = true;
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && IsPlayerAlive(i) && !GetEntProp(i, Prop_Send, "m_bIsDefusing"))
		{
			SetEntProp(i, Prop_Send, "m_iProgressBarDuration", Duration);
			SetEntPropFloat(i, Prop_Send, "m_flProgressBarStartTime", StartTime);
		}
	}
}